#ifndef CISO_H_

#define CISO_H_

#include "file.h"


int get_umd_id(char* id, const char* path, file_type type);


//form ciso.c in iso tool



typedef struct ciso_header
{
    unsigned char magic[4];         /* +00 : 'C','I','S','O'                 */
    unsigned long header_size;      /* +04 : header size (==0x18)            */
    unsigned long long total_bytes; /* +08 : number of original data size    */
    unsigned long block_size;       /* +10 : number of compressed block size */
    unsigned char ver;              /* +14 : version 01                      */
    unsigned char align;            /* +15 : align of index value            */
    unsigned char rsv_06[2];        /* +16 : reserved                        */
}CISO_H;

#define CISO_HEADER_SIZE (0x18)

/*---------------------------------------------------------------------------
  deflatẻ𓀂s
    char* o_buff 𓀐
    int o_size   𓀐obt@TCY
    char* i_buff 
    int i_size   ̓TCY

    Ԓl 𓀌̃TCY / G[̏ꍇ͕Ԃ
---------------------------------------------------------------------------*/
int inflate_cso(char* o_buff, int o_size, const char* i_buff, int i_size);

/*---------------------------------------------------------------------------
  CSOǍ
    char *buf        Ǎ݃obt@
    const char *path pX
    int pos          Ǎ݈ʒu
    int size         Ǎ݃TCY

    Ԓl ۂɓǂݍ񂾒 / G[̏ꍇ͕Ԃ
---------------------------------------------------------------------------*/
int cso_read(char *buf, const char *path, int pos, int size);

/*---------------------------------------------------------------------------
  CSOAœǍ
    char *buf Ǎ݃obt@
    SceUID fp t@C|C^
    int pos   Ǎ݈ʒu
    int size  Ǎ݃TCY

    Ԓl ۂɓǂݍ񂾒 / G[̏ꍇ͕Ԃ

    OsceIoOpen / IsceIoCloseKv
---------------------------------------------------------------------------*/
int cso_read_fp(char *buf, SceUID fp, int pos, int size);

#endif